Index: sys/netgraph/ng_ether.c
===================================================================
--- sys/netgraph/ng_ether.c	(revision 195689)
+++ sys/netgraph/ng_ether.c	(working copy)
@@ -74,7 +74,7 @@
 
 static vnet_attach_fn ng_ether_iattach;
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static vnet_modinfo_t vnet_ng_ether_modinfo = {
 	.vmi_id		= VNET_MOD_NG_ETHER,
 	.vmi_name	= "ng_ether",
@@ -783,7 +783,7 @@
 		ng_ether_input_orphan_p = ng_ether_input_orphan;
 		ng_ether_link_state_p = ng_ether_link_state;
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_ng_ether_modinfo);
 #else
 		error = ng_ether_iattach(NULL);
@@ -800,7 +800,7 @@
 		 * is MOD_UNLOAD, so there's no need to detach any nodes.
 		 */
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_deregister(&vnet_ng_ether_modinfo);
 #endif
 
@@ -823,7 +823,6 @@
 
 static int ng_ether_iattach(const void *unused)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 
 	/* Create nodes for any already-existing Ethernet interfaces. */
Index: sys/netgraph/ng_base.c
===================================================================
--- sys/netgraph/ng_base.c	(revision 195689)
+++ sys/netgraph/ng_base.c	(working copy)
@@ -68,6 +68,7 @@
 #include <machine/cpu.h>
 
 #include <net/netisr.h>
+#include <net/vnet.h>
 
 #include <netgraph/ng_message.h>
 #include <netgraph/netgraph.h>
@@ -75,16 +76,9 @@
 
 MODULE_VERSION(netgraph, NG_ABI_VERSION);
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-struct vnet_netgraph vnet_netgraph_0;
-#endif
-#endif
-
 /* Mutex to protect topology events. */
 static struct mtx	ng_topo_mtx;
 
-static vnet_attach_fn vnet_netgraph_iattach;
 #ifdef VIMAGE
 static vnet_detach_fn vnet_netgraph_idetach;
 #endif
@@ -182,9 +176,9 @@
 
 /* Hash related definitions */
 /* XXX Don't need to initialise them because it's a LIST */
-#ifdef VIMAGE_GLOBALS
-static LIST_HEAD(, ng_node) ng_ID_hash[NG_ID_HASH_SIZE];
-#endif
+static VNET_DEFINE(LIST_HEAD(, ng_node), ng_ID_hash[NG_ID_HASH_SIZE]);
+#define	V_ng_ID_hash			VNET_GET(ng_ID_hash)
+
 static struct mtx	ng_idhash_mtx;
 /* Method to find a node.. used twice so do it here */
 #define NG_IDHASH_FN(ID) ((ID) % (NG_ID_HASH_SIZE))
@@ -200,9 +194,9 @@
 		}							\
 	} while (0)
 
-#ifdef VIMAGE_GLOBALS
-static LIST_HEAD(, ng_node) ng_name_hash[NG_NAME_HASH_SIZE];
-#endif
+static VNET_DEFINE(LIST_HEAD(, ng_node), ng_name_hash[NG_NAME_HASH_SIZE]);
+#define	V_ng_name_hash			VNET_GET(ng_name_hash)
+
 static struct mtx	ng_namehash_mtx;
 #define NG_NAMEHASH(NAME, HASH)				\
 	do {						\
@@ -370,9 +364,8 @@
 #define TRAP_ERROR()
 #endif
 
-#ifdef VIMAGE_GLOBALS
-static	ng_ID_t nextID;
-#endif
+static VNET_DEFINE(ng_ID_t, nextID) = 1;
+#define	V_nextID			VNET_GET(nextID)
 
 #ifdef INVARIANTS
 #define CHECK_DATA_MBUF(m)	do {					\
@@ -634,7 +627,6 @@
 int
 ng_make_node_common(struct ng_type *type, node_p *nodepp)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	node_p node;
 
 	/* Require the node type to have been already installed */
@@ -819,7 +811,6 @@
 static node_p
 ng_ID2noderef(ng_ID_t ID)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	node_p node;
 	mtx_lock(&ng_idhash_mtx);
 	NG_IDHASH_FIND(ID, node);
@@ -845,7 +836,6 @@
 int
 ng_name_node(node_p node, const char *name)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	int i, hash;
 	node_p node2;
 
@@ -896,7 +886,6 @@
 node_p
 ng_name2noderef(node_p here, const char *name)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	node_p node;
 	ng_ID_t temp;
 	int	hash;
@@ -2457,7 +2446,6 @@
 static int
 ng_generic_msg(node_p here, item_p item, hook_p lasthook)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	int error = 0;
 	struct ng_mesg *msg;
 	struct ng_mesg *resp = NULL;
@@ -3080,37 +3068,24 @@
 	return (error);
 }
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static const vnet_modinfo_t vnet_netgraph_modinfo = {
 	.vmi_id		= VNET_MOD_NETGRAPH,
 	.vmi_name	= "netgraph",
-	.vmi_size	= sizeof(struct vnet_netgraph),
 	.vmi_dependson	= VNET_MOD_LOIF,
-	.vmi_iattach	= vnet_netgraph_iattach,
-#ifdef VIMAGE
 	.vmi_idetach	= vnet_netgraph_idetach
-#endif
 };
 #endif
 
-static int
-vnet_netgraph_iattach(const void *unused __unused)
-{
-	INIT_VNET_NETGRAPH(curvnet);
-
-	V_nextID = 1;
-
-	return (0);
-}
-
 #ifdef VIMAGE 
 static int
 vnet_netgraph_idetach(const void *unused __unused)
 {
-	INIT_VNET_NETGRAPH(curvnet);
+#if 0
 	node_p node, last_killed = NULL;
 
-	while ((node = LIST_FIRST(&V_ng_nodelist)) != NULL) {
+	/* XXXRW: utterly bogus. */
+	while ((node = LIST_FIRST(&V_ng_allnodes)) != NULL) {
 		if (node == last_killed) {
 			/* This should never happen */
 			node->nd_flags |= NGF_REALLY_DIE;
@@ -3118,13 +3093,14 @@
 			    node->nd_name);
 			ng_rmnode(node, NULL, NULL, 0);
 			/* This must never happen */
-			if (node == LIST_FIRST(&V_ng_nodelist))
+			if (node == LIST_FIRST(&V_ng_allnodes))
 				panic("netgraph node %s won't die",
 				    node->nd_name);
 		}
 		ng_rmnode(node, NULL, NULL, 0);
 		last_killed = node;
 	}
+#endif
 
 	return (0);
 }
@@ -3144,10 +3120,8 @@
 	switch (event) {
 	case MOD_LOAD:
 		/* Initialize everything. */
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_netgraph_modinfo);
-#else
-		vnet_netgraph_iattach(NULL);
 #endif
 		NG_WORKLIST_LOCK_INIT();
 		mtx_init(&ng_typelist_mtx, "netgraph types mutex", NULL,
Index: sys/netgraph/ng_iface.c
===================================================================
--- sys/netgraph/ng_iface.c	(revision 195689)
+++ sys/netgraph/ng_iface.c	(working copy)
@@ -212,11 +212,10 @@
 static vnet_attach_fn ng_iface_iattach;
 static vnet_detach_fn ng_iface_idetach;
 
-#ifdef VIMAGE_GLOBALS
-static struct unrhdr	*ng_iface_unit;
-#endif
+static VNET_DEFINE(struct unrhdr *, ng_iface_unit);
+#define	V_ng_iface_unit			VNET_GET(ng_iface_unit)
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static vnet_modinfo_t vnet_ng_iface_modinfo = {
 	.vmi_id		= VNET_MOD_NG_IFACE,
 	.vmi_name	= "ng_iface",
@@ -542,7 +541,6 @@
 static int
 ng_iface_constructor(node_p node)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	struct ifnet *ifp;
 	priv_p priv;
 
@@ -806,7 +804,6 @@
 static int
 ng_iface_shutdown(node_p node)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 	const priv_p priv = NG_NODE_PRIVATE(node);
 
 	/*
@@ -852,14 +849,14 @@
 
 	switch (event) {
 	case MOD_LOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_register(&vnet_ng_iface_modinfo);
 #else
 		ng_iface_iattach(NULL);
 #endif
 		break;
 	case MOD_UNLOAD:
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 		vnet_mod_deregister(&vnet_ng_iface_modinfo);
 #else
 		ng_iface_idetach(NULL);
@@ -874,7 +871,6 @@
 
 static int ng_iface_iattach(const void *unused)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 
 	V_ng_iface_unit = new_unrhdr(0, 0xffff, NULL);
 
@@ -883,7 +879,6 @@
 
 static int ng_iface_idetach(const void *unused)
 {
-	INIT_VNET_NETGRAPH(curvnet);
 
 	delete_unrhdr(V_ng_iface_unit);
 
Index: sys/netgraph/netgraph.h
===================================================================
--- sys/netgraph/netgraph.h	(revision 195689)
+++ sys/netgraph/netgraph.h	(working copy)
@@ -1218,36 +1218,4 @@
 		    ("%s: negative td_ng_outbound", __func__));		\
 	} while (0)
 
-/* Virtualization macros */
-#define	INIT_VNET_NETGRAPH(vnet) \
-	INIT_FROM_VNET(vnet, VNET_MOD_NETGRAPH, \
-	    struct vnet_netgraph, vnet_netgraph)
-
-#define	VNET_NETGRAPH(sym)	VSYM(vnet_netgraph, sym)
-
-struct vnet_netgraph {
-	LIST_HEAD(, ng_node)	 _ng_ID_hash[NG_ID_HASH_SIZE];
-	LIST_HEAD(, ng_node)	 _ng_name_hash[NG_NAME_HASH_SIZE];
-	LIST_HEAD(, ng_node)	 _ng_nodelist;
-	ng_ID_t			 _nextID;
-	struct unrhdr		*_ng_iface_unit;
-	struct unrhdr		*_ng_eiface_unit;
-	struct unrhdr		*_ng_wormhole_unit;
-};
-
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-extern struct vnet_netgraph vnet_netgraph_0;
-#endif
-#endif
-
-/* Symbol translation macros */
-#define	V_nextID		VNET_NETGRAPH(nextID)
-#define	V_ng_ID_hash		VNET_NETGRAPH(ng_ID_hash)
-#define	V_ng_eiface_unit	VNET_NETGRAPH(ng_eiface_unit)
-#define	V_ng_iface_unit		VNET_NETGRAPH(ng_iface_unit)
-#define	V_ng_name_hash		VNET_NETGRAPH(ng_name_hash)
-#define	V_ng_nodelist		VNET_NETGRAPH(ng_nodelist)
-#define	V_ng_wormhole_unit	VNET_NETGRAPH(ng_wormhole_unit)
-
 #endif /* _NETGRAPH_NETGRAPH_H_ */
Index: sys/netgraph/ng_gif.c
===================================================================
--- sys/netgraph/ng_gif.c	(revision 195689)
+++ sys/netgraph/ng_gif.c	(working copy)
@@ -565,7 +565,6 @@
 		VNET_LIST_RLOCK();
 		VNET_FOREACH(vnet_iter) {
 			CURVNET_SET_QUIET(vnet_iter); /* XXX revisit quiet */
-			INIT_VNET_NET(curvnet);
 			TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
 				if (ifp->if_type == IFT_GIF)
 					ng_gif_attach(ifp);
Index: sys/fs/nfsclient/nfs_clvnops.c
===================================================================
--- sys/fs/nfsclient/nfs_clvnops.c	(revision 195689)
+++ sys/fs/nfsclient/nfs_clvnops.c	(working copy)
@@ -75,7 +75,6 @@
 #include <fs/nfsclient/nfs_lock.h>
 
 #include <net/if.h>
-#include <netinet/vinet.h>
 #include <netinet/in.h>
 #include <netinet/in_var.h>
 
@@ -1401,7 +1400,6 @@
 
 	CURVNET_SET(P_TO_VNET(&proc0));
 #ifdef INET
-	INIT_VNET_INET(curvnet);
 	IN_IFADDR_RLOCK();
 	if (!TAILQ_EMPTY(&V_in_ifaddrhead))
 		cverf.lval[0] = IA_SIN(TAILQ_FIRST(&V_in_ifaddrhead))->sin_addr.s_addr;
Index: sys/fs/nfs/nfsport.h
===================================================================
--- sys/fs/nfs/nfsport.h	(revision 195689)
+++ sys/fs/nfs/nfsport.h	(working copy)
@@ -95,7 +95,6 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_timer.h>
 #include <netinet/tcp_var.h>
-#include <netinet/vinet.h>
 #include <machine/in_cksum.h>
 #include <crypto/des/des.h>
 #include <sys/md5.h>
Index: sys/fs/nfsserver/nfs_nfsdport.c
===================================================================
--- sys/fs/nfsserver/nfs_nfsdport.c	(revision 195689)
+++ sys/fs/nfsserver/nfs_nfsdport.c	(working copy)
@@ -2671,7 +2671,6 @@
 int
 nfsrv_getsocksndseq(struct socket *so, tcp_seq *maxp, tcp_seq *unap)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct inpcb *inp;
 	struct tcpcb *tp;
 	int error = EPIPE;
Index: sys/dev/cxgb/ulp/tom/cxgb_cpl_io.c
===================================================================
--- sys/dev/cxgb/ulp/tom/cxgb_cpl_io.c	(revision 195689)
+++ sys/dev/cxgb/ulp/tom/cxgb_cpl_io.c	(working copy)
@@ -78,9 +78,6 @@
 #include <netinet/tcp_seq.h>
 #include <netinet/tcp_syncache.h>
 #include <netinet/tcp_timer.h>
-#if __FreeBSD_version >= 800056
-#include <netinet/vinet.h>
-#endif
 #include <net/route.h>
 
 #include <t3cdev.h>
@@ -274,7 +271,6 @@
 static inline void
 make_tx_data_wr(struct socket *so, struct mbuf *m, int len, struct mbuf *tail)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct tcpcb *tp = so_sototcpcb(so);
 	struct toepcb *toep = tp->t_toe;
 	struct tx_data_wr *req;
@@ -1219,7 +1215,6 @@
 static __inline int
 select_rcv_wscale(int space, struct vnet *vnet)
 {
-	INIT_VNET_INET(vnet);
 	int wscale = 0;
 
 	if (space > MAX_RCV_WND)
@@ -1237,7 +1232,6 @@
 static unsigned long
 select_rcv_wnd(struct toedev *dev, struct socket *so)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct tom_data *d = TOM_DATA(dev);
 	unsigned int wnd;
 	unsigned int max_rcv_wnd;
@@ -3780,7 +3774,6 @@
 static void
 socket_act_establish(struct socket *so, struct mbuf *m)
 {
-	INIT_VNET_INET(so->so_vnet);
 	struct cpl_act_establish *req = cplhdr(m);
 	u32 rcv_isn = ntohl(req->rcv_isn);	/* real RCV_ISN + 1 */
 	struct tcpcb *tp = so_sototcpcb(so);
Index: sys/dev/cxgb/ulp/iw_cxgb/iw_cxgb.c
===================================================================
--- sys/dev/cxgb/ulp/iw_cxgb/iw_cxgb.c	(revision 195689)
+++ sys/dev/cxgb/ulp/iw_cxgb/iw_cxgb.c	(working copy)
@@ -240,7 +240,6 @@
 	VNET_LIST_RLOCK();
 	VNET_FOREACH(vnet_iter) {
 		CURVNET_SET(vnet_iter); /* XXX CURVNET_SET_QUIET() ? */
-		INIT_VNET_NET(vnet_iter);
 		TAILQ_FOREACH(ifp, &V_ifnet, if_link)
 			(void)ifaddr_event_handler(NULL, ifp);
 		CURVNET_RESTORE();
Index: sys/net80211/ieee80211_ddb.c
===================================================================
--- sys/net80211/ieee80211_ddb.c	(revision 195689)
+++ sys/net80211/ieee80211_ddb.c	(working copy)
@@ -165,7 +165,6 @@
 		}
 
 	VNET_FOREACH(vnet_iter) {
-		INIT_VNET_NET(vnet_iter);
 		TAILQ_FOREACH(ifp, &V_ifnet, if_list)
 			if (ifp->if_type == IFT_IEEE80211) {
 				const struct ieee80211com *ic = ifp->if_l2com;
Index: sys/compat/linprocfs/linprocfs.c
===================================================================
--- sys/compat/linprocfs/linprocfs.c	(revision 195689)
+++ sys/compat/linprocfs/linprocfs.c	(working copy)
@@ -1078,7 +1078,6 @@
 static int
 linprocfs_donetdev(PFS_FILL_ARGS)
 {
-	INIT_VNET_NET(TD_TO_VNET(td));
 	char ifname[16]; /* XXX LINUX_IFNAMSIZ */
 	struct ifnet *ifp;
 
Index: sys/compat/linux/linux_socket.c
===================================================================
--- sys/compat/linux/linux_socket.c	(revision 195689)
+++ sys/compat/linux/linux_socket.c	(working copy)
@@ -60,7 +60,6 @@
 #include <netinet/ip6.h>
 #include <netinet6/ip6_var.h>
 #include <netinet6/in6_var.h>
-#include <netinet6/vinet6.h>
 #endif
 
 #ifdef COMPAT_LINUX32
@@ -599,11 +598,6 @@
 static int
 linux_socket(struct thread *td, struct linux_socket_args *args)
 {
-#ifdef INET6
-#ifndef KLD_MODULE
-	INIT_VNET_INET6(curvnet);
-#endif
-#endif
 	struct socket_args /* {
 		int domain;
 		int type;
Index: sys/compat/linux/linux_ioctl.c
===================================================================
--- sys/compat/linux/linux_ioctl.c	(revision 195689)
+++ sys/compat/linux/linux_ioctl.c	(working copy)
@@ -2059,7 +2059,6 @@
 int
 linux_ifname(struct ifnet *ifp, char *buffer, size_t buflen)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	struct ifnet *ifscan;
 	int ethno;
 
@@ -2093,7 +2092,6 @@
 static struct ifnet *
 ifname_linux_to_bsd(struct thread *td, const char *lxname, char *bsdname)
 {
-	INIT_VNET_NET(TD_TO_VNET(td));
 	struct ifnet *ifp;
 	int len, unit;
 	char *ep;
@@ -2134,7 +2132,6 @@
 static int
 linux_ifconf(struct thread *td, struct ifconf *uifc)
 {
-	INIT_VNET_NET(TD_TO_VNET(td));
 #ifdef COMPAT_LINUX32
 	struct l_ifconf ifc;
 #else
Index: sys/compat/svr4/svr4_sockio.c
===================================================================
--- sys/compat/svr4/svr4_sockio.c	(revision 195689)
+++ sys/compat/svr4/svr4_sockio.c	(working copy)
@@ -89,7 +89,6 @@
 	switch (cmd) {
 	case SVR4_SIOCGIFNUM:
 		{
-			INIT_VNET_NET(curvnet);
 			struct ifnet *ifp;
 			struct ifaddr *ifa;
 			int ifnum = 0;
Index: sys/net/if.c
===================================================================
--- sys/net/if.c	(revision 195689)
+++ sys/net/if.c	(working copy)
@@ -84,7 +84,6 @@
 #endif
 #ifdef INET
 #include <netinet/if_ether.h>
-#include <netinet/vinet.h>
 #endif
 #if defined(INET) || defined(INET6)
 #ifdef DEV_CARP
@@ -94,12 +93,6 @@
 
 #include <security/mac/mac_framework.h>
 
-#ifndef VIMAGE
-#ifndef VIMAGE_GLOBALS
-struct vnet_net vnet_net_0;
-#endif
-#endif
-
 struct ifindex_entry {
 	struct  ifnet *ife_ifnet;
 };
@@ -162,37 +155,30 @@
 static int	vnet_net_idetach(const void *);
 #endif
 
-#ifdef VIMAGE_GLOBALS
-struct	ifnethead ifnet;	/* depend on static init XXX */
-struct	ifgrouphead ifg_head;
-int	if_index;
-static	int if_indexlim;
+VNET_DEFINE(struct ifnethead, ifnet);	/* depend on static init XXX */
+VNET_DEFINE(struct ifgrouphead, ifg_head);
+VNET_DEFINE(int, if_index);
+static VNET_DEFINE(int, if_indexlim) = 8;
+
 /* Table of ifnet by index.  Locked with ifnet_lock. */
-static struct ifindex_entry *ifindex_table;
-#endif
+static VNET_DEFINE(struct ifindex_entry *, ifindex_table);
 
+#define	V_if_indexlim		VNET_GET(if_indexlim)
+#define	V_ifindex_table		VNET_GET(ifindex_table)
+
 int	ifqmaxlen = IFQ_MAXLEN;
 struct rwlock ifnet_lock;
 static	if_com_alloc_t *if_com_alloc[256];
 static	if_com_free_t *if_com_free[256];
 
-#ifndef VIMAGE_GLOBALS
-static struct vnet_symmap vnet_net_symmap[] = {
-	VNET_SYMMAP(net, ifnet),
-	VNET_SYMMAP_END
-};
-
+#ifdef VIMAGE
 static const vnet_modinfo_t vnet_net_modinfo = {
 	.vmi_id		= VNET_MOD_NET,
 	.vmi_name	= "net",
-	.vmi_size	= sizeof(struct vnet_net),
-	.vmi_symmap	= vnet_net_symmap,
 	.vmi_iattach	= vnet_net_iattach,
-#ifdef VIMAGE
 	.vmi_idetach	= vnet_net_idetach
-#endif
 };
-#endif /* !VIMAGE_GLOBALS */
+#endif
 
 /*
  * System initialization
@@ -207,7 +193,6 @@
 struct ifnet *
 ifnet_byindex_locked(u_short idx)
 {
-	INIT_VNET_NET(curvnet);
 
 	if (idx > V_if_index)
 		return (NULL);
@@ -244,7 +229,6 @@
 static void
 ifnet_setbyindex(u_short idx, struct ifnet *ifp)
 {
-	INIT_VNET_NET(curvnet);
 
 	IFNET_WLOCK_ASSERT();
 
@@ -276,7 +260,7 @@
 if_init(void *dummy __unused)
 {
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_register(&vnet_net_modinfo);
 #else
 	vnet_net_iattach(NULL);
@@ -289,12 +273,7 @@
 static int
 vnet_net_iattach(const void *unused __unused)
 {
-	INIT_VNET_NET(curvnet);
 
-	V_if_index = 0;
-	V_ifindex_table = NULL;
-	V_if_indexlim = 8;
-
 	TAILQ_INIT(&V_ifnet);
 	TAILQ_INIT(&V_ifg_head);
 	if_grow();				/* create initial table */
@@ -306,7 +285,6 @@
 static int
 vnet_net_idetach(const void *unused __unused)
 {
-	INIT_VNET_NET(curvnet);
 
 	VNET_ASSERT(TAILQ_EMPTY(&V_ifnet));
 	VNET_ASSERT(TAILQ_EMPTY(&V_ifg_head));
@@ -320,7 +298,6 @@
 void
 if_grow(void)
 {
-	INIT_VNET_NET(curvnet);
 	u_int n;
 	struct ifindex_entry *e;
 
@@ -354,7 +331,6 @@
 struct ifnet *
 if_alloc(u_char type)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 
 	ifp = malloc(sizeof(struct ifnet), M_IFNET, M_WAITOK|M_ZERO);
@@ -418,7 +394,6 @@
 static void
 if_free_internal(struct ifnet *ifp)
 {
-	INIT_VNET_NET(curvnet);		/* ifp->if_vnet is already NULL here */
 
 	KASSERT((ifp->if_flags & IFF_DYING),
 	    ("if_free_internal: interface not dying"));
@@ -544,7 +519,6 @@
 static void
 if_attach_internal(struct ifnet *ifp, int vmove)
 {
-	INIT_VNET_NET(curvnet);
 	unsigned socksize, ifasize;
 	int namelen, masklen;
 	struct sockaddr_dl *sdl;
@@ -649,7 +623,6 @@
 static void
 if_attachdomain(void *dummy)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	int s;
 
@@ -769,7 +742,6 @@
 static void
 if_detach_internal(struct ifnet *ifp, int vmove)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	struct ifaddr *ifa;
 	struct radix_node_head	*rnh;
 	int i, j;
@@ -904,25 +876,17 @@
 	/*
 	 * Unlink the ifnet from ifindex_table[] in current vnet,
 	 * and shrink the if_index for that vnet if possible.
-	 * do / while construct below is needed to confine the scope
-	 * of INIT_VNET_NET().
 	 */
-	{
-		INIT_VNET_NET(curvnet);
+	IFNET_WLOCK();
+	ifnet_setbyindex(ifp->if_index, NULL);
+	while (V_if_index > 0 && ifnet_byindex_locked(V_if_index) == NULL)
+		V_if_index--;
+	IFNET_WUNLOCK();
 
-		IFNET_WLOCK();
-		ifnet_setbyindex(ifp->if_index, NULL);
-		while (V_if_index > 0 && \
-		    ifnet_byindex_locked(V_if_index) == NULL)
-			V_if_index--;
-		IFNET_WUNLOCK();
-	};
-
 	/*
 	 * Switch to the context of the target vnet.
 	 */
 	CURVNET_SET_QUIET(new_vnet);
-	INIT_VNET_NET(new_vnet);
 
 	/*
 	 * Try to find an empty slot below if_index.  If we fail, take 
@@ -956,7 +920,6 @@
 int
 if_addgroup(struct ifnet *ifp, const char *groupname)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	struct ifg_list		*ifgl;
 	struct ifg_group	*ifg = NULL;
 	struct ifg_member	*ifgm;
@@ -1026,7 +989,6 @@
 int
 if_delgroup(struct ifnet *ifp, const char *groupname)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	struct ifg_list		*ifgl;
 	struct ifg_member	*ifgm;
 
@@ -1072,7 +1034,6 @@
 static void
 if_delgroups(struct ifnet *ifp)
 {
-	INIT_VNET_NET(ifp->if_vnet);
 	struct ifg_list		*ifgl;
 	struct ifg_member	*ifgm;
 	char groupname[IFNAMSIZ];
@@ -1164,7 +1125,6 @@
 static int
 if_getgroupmembers(struct ifgroupreq *data)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifgroupreq	*ifgr = data;
 	struct ifg_group	*ifg;
 	struct ifg_member	*ifgm;
@@ -1336,7 +1296,6 @@
 static struct ifaddr *
 ifa_ifwithaddr_internal(struct sockaddr *addr, int getref)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 
@@ -1392,7 +1351,6 @@
 struct ifaddr *
 ifa_ifwithbroadaddr(struct sockaddr *addr)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 
@@ -1426,7 +1384,6 @@
 struct ifaddr *
 ifa_ifwithdstaddr(struct sockaddr *addr)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 
@@ -1460,7 +1417,6 @@
 struct ifaddr *
 ifa_ifwithnet(struct sockaddr *addr)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 	struct ifaddr *ifa;
 	struct ifaddr *ifa_maybe = NULL;
@@ -1841,7 +1797,6 @@
 	VNET_LIST_RLOCK();
 	VNET_FOREACH(vnet_iter) {
 		CURVNET_SET(vnet_iter);
-		INIT_VNET_NET(vnet_iter);
 		TAILQ_FOREACH(ifp, &V_ifnet, if_link) {
 			if (ifp->if_timer == 0 || --ifp->if_timer)
 				continue;
@@ -1863,7 +1818,6 @@
 struct ifnet *
 ifunit_ref(const char *name)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 
 	IFNET_RLOCK();
@@ -1881,7 +1835,6 @@
 struct ifnet *
 ifunit(const char *name)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifnet *ifp;
 
 	IFNET_RLOCK();
@@ -2478,7 +2431,6 @@
 static int
 ifconf(u_long cmd, caddr_t data)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifconf *ifc = (struct ifconf *)data;
 #ifdef __amd64__
 	struct ifconf32 *ifc32 = (struct ifconf32 *)data;
@@ -2837,7 +2789,6 @@
 	int lastref;
 #ifdef INVARIANTS
 	struct ifnet *oifp;
-	INIT_VNET_NET(ifp->if_vnet);
 
 	IFNET_RLOCK();
 	TAILQ_FOREACH(oifp, &V_ifnet, if_link)
@@ -2878,9 +2829,6 @@
 void
 if_delmulti_ifma(struct ifmultiaddr *ifma)
 {
-#ifdef DIAGNOSTIC
-	INIT_VNET_NET(curvnet);
-#endif
 	struct ifnet *ifp;
 	int lastref;
 
Index: sys/net/if_stf.c
===================================================================
--- sys/net/if_stf.c	(revision 195689)
+++ sys/net/if_stf.c	(working copy)
@@ -106,7 +106,6 @@
 #include <netinet/ip.h>
 #include <netinet/ip_var.h>
 #include <netinet/in_var.h>
-#include <netinet/vinet.h>
 
 #include <netinet/ip6.h>
 #include <netinet6/ip6_var.h>
@@ -378,7 +377,6 @@
 stf_getsrcifa6(ifp)
 	struct ifnet *ifp;
 {
-	INIT_VNET_INET(ifp->if_vnet);
 	struct ifaddr *ia;
 	struct in_ifaddr *ia4;
 	struct sockaddr_in6 *sin6;
@@ -596,7 +594,6 @@
 	struct in_addr *in;
 	struct ifnet *inifp;	/* incoming interface */
 {
-	INIT_VNET_INET(curvnet);
 	struct in_ifaddr *ia4;
 
 	/*
Index: sys/net/if_clone.c
===================================================================
--- sys/net/if_clone.c	(revision 195689)
+++ sys/net/if_clone.c	(working copy)
@@ -58,11 +58,12 @@
 static int	vnet_clone_iattach(const void *);
 
 static struct mtx	if_cloners_mtx;
-#ifdef VIMAGE_GLOBALS
-static int		if_cloners_count;
-LIST_HEAD(, if_clone)	if_cloners;
-#endif
+static VNET_DEFINE(int, if_cloners_count);
+VNET_DEFINE(LIST_HEAD(, if_clone), if_cloners);
 
+#define	V_if_cloners_count	VNET_GET(if_cloners_count)
+#define	V_if_cloners		VNET_GET(if_cloners)
+
 #define IF_CLONERS_LOCK_INIT()		\
     mtx_init(&if_cloners_mtx, "if_cloners lock", NULL, MTX_DEF)
 #define IF_CLONERS_LOCK_ASSERT()	mtx_assert(&if_cloners_mtx, MA_OWNED)
@@ -115,17 +116,16 @@
 
 static MALLOC_DEFINE(M_CLONE, "clone", "interface cloning framework");
 
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 static const vnet_modinfo_t vnet_clone_modinfo = {
 	.vmi_id		= VNET_MOD_IF_CLONE,
 	.vmi_name	= "if_clone",
 	.vmi_iattach	= vnet_clone_iattach
 };
-#endif /* !VIMAGE_GLOBALS */
+#endif
 
 static int vnet_clone_iattach(const void *unused __unused)
 {
-	INIT_VNET_NET(curvnet);
 
 	LIST_INIT(&V_if_cloners);
 	return (0);
@@ -136,7 +136,7 @@
 {
 
 	IF_CLONERS_LOCK_INIT();
-#ifndef VIMAGE_GLOBALS
+#ifdef VIMAGE
 	vnet_mod_register(&vnet_clone_modinfo);
 #else
 	vnet_clone_iattach(NULL);
@@ -149,7 +149,6 @@
 int
 if_clone_create(char *name, size_t len, caddr_t params)
 {
-	INIT_VNET_NET(curvnet);
 	struct if_clone *ifc;
 
 	/* Try to find an applicable cloner for this request */
@@ -162,7 +161,6 @@
 #ifdef VIMAGE
 	if (ifc == NULL && !IS_DEFAULT_VNET(curvnet)) {
 		CURVNET_SET_QUIET(vnet0);
-		INIT_VNET_NET(vnet0);
 		LIST_FOREACH(ifc, &V_if_cloners, ifc_list) {
 			if (ifc->ifc_match(ifc, name))
 				break;
@@ -213,7 +211,6 @@
 int
 if_clone_destroy(const char *name)
 {
-	INIT_VNET_NET(curvnet);
 	struct if_clone *ifc;
 	struct ifnet *ifp;
 
@@ -231,7 +228,6 @@
 #ifdef VIMAGE
 	if (ifc == NULL && !IS_DEFAULT_VNET(curvnet)) {
 		CURVNET_SET_QUIET(vnet0);
-		INIT_VNET_NET(vnet0);
 		LIST_FOREACH(ifc, &V_if_cloners, ifc_list) {
 			if (ifc->ifc_match(ifc, name))
 				break;
@@ -289,7 +285,6 @@
 void
 if_clone_attach(struct if_clone *ifc)
 {
-	INIT_VNET_NET(curvnet);
 	int len, maxclone;
 
 	/*
@@ -322,7 +317,6 @@
 void
 if_clone_detach(struct if_clone *ifc)
 {
-	INIT_VNET_NET(curvnet);
 	struct ifc_simple_data *ifcs = ifc->ifc_data;
 
 	IF_CLONERS_LOCK();
@@ -362,7 +356,6 @@
 int
 if_clone_list(struct if_clonereq *ifcr)
 {
-	INIT_VNET_NET(curvnet);
 	char *buf, *dst, *outbuf = NULL;
 	struct if_clone *ifc;
 	int buf_count, count, err = 0;
